10 PRINT "ROMDUMP"
15 A$ = "ROMDUMP.BIN"
20 PRINT "THIS WILL DUMP ROM TO " A$: PRINT
25 PRINT "NB: TAKE A BACKUP OF YOUR SD CARD FIRST!": PRINT
30 PRINT "PROCEED? YES/NO"
40 INPUT "Y/N"; B$
50 IF B$ <> "Y" THEN END
60 GOSUB 2000
100 FOR I=0 TO 31
110 PRINT "BANK " I
120 POKE $030C,I
130 SYS $400
131 IF I=0 THEN BSAVE "@:" + A$,8,1,$4000,$8000: GOTO 140
135 BSAVE A$ + ",S,A",8,1,$4000,$8000
140 NEXT I
490 END
500 REM UNUSED ALTERNATIVE TO THE MACHINE CODE COPY
505 REM SLOW, TAKES 17 SECONDS PR BANK
508 REM REQUIRES THAT ROM BANK IS SELECTED WITH BANK CMD
510 FOR J=$4000 TO $7FFF: POKE J,PEEK($8000+J): NEXT J
520 RETURN
1000 REM                ZP.SRC.PTR=2
1010 REM                ZP.DEST.PTR=4
1015 DATA $A6,$01 : REM LDX $01 ; PRESERVE ROM BANK
1016 DATA $85,$01 : REM STA $01 ; SET ROM BANK ($030C)
1020 DATA $A9,$C0 : REM LDA #$C0
1030 DATA $85,$03 : REM STA ZP.SRC.PTR+1
1040 DATA $A9,$40 : REM LDA #$40
1050 DATA $85,$05 : REM STA ZP.DEST.PTR+1
1060 DATA $A0,$00 : REM LDY #0
1070 DATA $64,$02 : REM STZ ZP.SRC.PTR
1080 DATA $64,$04 : REM STZ ZP.DEST.PTR
1090 REM                LOOP:
1100 DATA $B1,$02 : REM LDA (ZP.SRC.PTR),Y
1110 DATA $91,$04 : REM STA (ZP.DEST.PTR),Y
1120 DATA $C8     : REM INY
1130 DATA $D0,$F9 : REM BNE LOOP
1140 DATA $E6,$05 : REM INC ZP.DEST.PTR+1
1150 DATA $E6,$03 : REM INC ZP.SRC.PTR+1
1160 DATA $D0,$F3 : REM BNE LOOP
1165 DATA $86,$01 : REM STX $01 ; RESTORE BASIC ROM BANK
1170 DATA $60     : REM RTS
2000 FOR X=0 TO 33: READ A: POKE $400+X,A: NEXT X
2010 RETURN
